"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var utils_1 = require("@react-md/utils");
var getProgress_1 = __importDefault(require("./getProgress"));
var block = utils_1.bem("rmd-linear-progress");
var LinearProgress = function (providedProps) {
    var _a = providedProps, propStyle = _a.style, className = _a.className, propBarStyle = _a.barStyle, barClassName = _a.barClassName, min = _a.min, max = _a.max, value = _a.value, reverse = _a.reverse, animate = _a.animate, vertical = _a.vertical, verticalHeight = _a.verticalHeight, forwardedRef = _a.forwardedRef, props = __rest(_a, ["style", "className", "barStyle", "barClassName", "min", "max", "value", "reverse", "animate", "vertical", "verticalHeight", "forwardedRef"]);
    var style = react_1.useMemo(function () {
        if (!vertical || verticalHeight === null) {
            return propStyle;
        }
        return __assign({}, propStyle, { height: verticalHeight });
    }, [propStyle, vertical, verticalHeight]);
    var progress = getProgress_1.default(min, max, value);
    var barStyle = react_1.useMemo(function () {
        var _a;
        if (typeof progress !== "number") {
            return propBarStyle;
        }
        var key = vertical ? "height" : "width";
        return __assign({}, propBarStyle, (_a = {}, _a[key] = progress * 100 + "%", _a));
    }, [progress, propBarStyle, vertical]);
    var determinate = typeof progress === "number";
    var indeterminate = !determinate;
    return (react_1.default.createElement("span", __assign({}, props, { style: style, role: "progressbar", "aria-valuemin": min, "aria-valuemax": max, "aria-valuenow": value, ref: forwardedRef, className: classnames_1.default(block({
            vertical: vertical,
            determinate: determinate,
            indeterminate: indeterminate,
        }), className) }),
        react_1.default.createElement("span", { style: barStyle, className: classnames_1.default(block("bar", {
                vertical: vertical,
                "vertical-reverse": vertical && reverse,
                horizontal: !vertical,
                "horizontal-reverse": !vertical && reverse,
                animate: animate && determinate,
                determinate: determinate,
                indeterminate: indeterminate,
                "determinate-reverse": determinate && reverse && !vertical,
                "determinate-vertical-reverse": determinate && reverse && vertical,
                "indeterminate-reverse": indeterminate && reverse && !vertical,
                "indeterminate-vertical": indeterminate && vertical,
                "indeterminate-vertical-reverse": indeterminate && reverse && vertical,
            }), barClassName) })));
};
var defaultProps = {
    min: 0,
    max: 100,
    animate: true,
    reverse: false,
    vertical: false,
    verticalHeight: 240,
};
LinearProgress.defaultProps = defaultProps;
if (process.env.NODE_ENV !== "production") {
    LinearProgress.displayName = "LinearProgress";
    var PropTypes = null;
    try {
        PropTypes = require("prop-types");
    }
    catch (e) { }
    if (PropTypes) {
        LinearProgress.propTypes = {
            id: PropTypes.string.isRequired,
            min: PropTypes.number,
            max: PropTypes.number,
            value: PropTypes.number,
            animate: PropTypes.bool,
            barStyle: PropTypes.object,
            barClassName: PropTypes.string,
            reverse: PropTypes.bool,
            vertical: PropTypes.bool,
            verticalHeight: PropTypes.number,
        };
    }
}
exports.default = LinearProgress;
//# sourceMappingURL=LinearProgress.js.map